import { Observable } from 'rxjs';
import { _NgScrollbar } from '../utils/scrollbar-base';
import { ScrollbarManager } from '../utils/scrollbar-manager';
import * as i0 from "@angular/core";
export declare abstract class ThumbAdapter {
    private readonly zone;
    protected readonly document: Document;
    protected readonly cmp: _NgScrollbar;
    protected readonly manager: ScrollbarManager;
    private readonly track;
    readonly nativeElement: HTMLElement;
    protected animation: Animation;
    protected abstract get clientProperty(): string;
    abstract get dragStartOffset(): number;
    abstract get offset(): number;
    abstract get size(): number;
    abstract get viewportScrollMax(): number;
    protected abstract axis: 'x' | 'y';
    get trackMax(): number;
    get clientRect(): DOMRect;
    /**
     * Stream that emits the 'scrollTo' position when a scrollbar thumb element is dragged
     * This function is called by thumb drag event using viewport or scrollbar pointer events
     */
    get dragged(): Observable<number>;
    constructor();
    private setDragging;
    protected abstract scrollTo(position: number): void;
    protected abstract handleDrag(position: number, scrollMax?: number): number;
    static ɵfac: i0.ɵɵFactoryDeclaration<ThumbAdapter, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<ThumbAdapter, never, never, {}, {}, never, never, false, never>;
}
